package cmdUser

import (
	nc "gitedu.hesge.ch/flg_projects/nexus_vdi/nexus/libclient/nexusclient"
	u "gitedu.hesge.ch/flg_projects/nexus_vdi/nexus/nexush/utils"
)

type ResetPwd struct {
	Name string
}

func (cmd *ResetPwd) GetName() string {
	return cmd.Name
}

func (cmd *ResetPwd) GetDesc() []string {
	return []string{
		"Reset password for one or more users.",
		"Requires USER_RESETPWD user capability."}
}

func (cmd *ResetPwd) PrintUsage() {
	for _, desc := range cmd.GetDesc() {
		u.PrintlnErr(desc)
	}
	u.PrintlnErr("―――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――")
	u.PrintlnErr("USAGE: " + cmd.GetName() + " email [email ...]")
	u.PrintlnErr("―――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――")
}

func (cmd *ResetPwd) Run(client *nc.NexusClient, args []string) int {
	argc := len(args)
	if argc < 1 {
		cmd.PrintUsage()
		return 1
	}

	// Iterates through each user (email) and reset their password
	for i := range args {
		email := args[i]
		newpwd, err := client.UserResetPwd(email)
		if err != nil {
			u.PrintlnErr(err)
			return 1
		} else {
			u.Println("New password for user " + email + ": " + newpwd)
		}
	}

	return 0
}
