package cmdVM

import (
	nc "gitedu.hesge.ch/flg_projects/nexus_vdi/nexus/libclient/nexusclient"
	u "gitedu.hesge.ch/flg_projects/nexus_vdi/nexus/nexush/utils"
)

type Attach struct {
	Name string
}

func (cmd *Attach) GetName() string {
	return cmd.Name
}

func (cmd *Attach) GetDesc() []string {
	return []string{
		"Attaches to one or more VMs in order to use their desktop environment.",
		"If not the VM's owner: requires VM_ATTACH VM access capability or VM_ATTACH_ANY user capability."}
}

func (cmd *Attach) PrintUsage() {
	printRegexUsage(cmd)
	printRegexUsageDetails()
}

func (cmd *Attach) Run(client *nc.NexusClient, args []string) int {
	argc := len(args)
	if argc < 1 {
		cmd.PrintUsage()
		return 1
	}

	credsList, err := getFilteredAttachVMsCreds(client, args)
	if err != nil {
		u.PrintlnErr(err)
		return 1
	}
	if len(credsList) < 1 {
		u.PrintlnErr("VM(s) not found")
		return 1
	}

	for _, creds := range credsList {
		go func() {
			err := client.VMAttachFromCreds(creds, false)
			if err != nil {
				u.PrintlnErr("Failed attaching to VM: " + err.Error())
			}
		}()
	}

	return 0
}
