package cmdVM

import (
	nc "gitedu.hesge.ch/flg_projects/nexus_vdi/nexus/libclient/nexusclient"
	u "gitedu.hesge.ch/flg_projects/nexus_vdi/nexus/nexush/utils"
)

type AttachFromPwd struct {
	Name string
}

func (cmd *AttachFromPwd) GetName() string {
	return cmd.Name
}

func (cmd *AttachFromPwd) GetDesc() []string {
	return []string{
		"Attaches to the VM that matches the specified password.",
		"Requires either EXAM_ATTACH or VM_ATTACH_ANY user capability."}
}

func (cmd *AttachFromPwd) PrintUsage() {
	for _, desc := range cmd.GetDesc() {
		u.PrintlnErr(desc)
	}
	u.PrintlnErr("―――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――")
	u.PrintlnErr("USAGE: ", cmd.GetName(), " password")
	u.PrintlnErr("―――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――")
}

func (cmd *AttachFromPwd) Run(client *nc.NexusClient, args []string) int {
	argc := len(args)
	if argc != 1 {
		cmd.PrintUsage()
		return 1
	}

	pwd := args[0]

	go func() {
		err := client.VMAttachFromPwd(pwd, true)
		if err != nil {
			u.PrintlnErr("Failed attaching to VM (from pwd): " + err.Error())
		}
	}()

	return 0
}
