package cmdVM

import (
	nc "gitedu.hesge.ch/flg_projects/nexus_vdi/nexus/libclient/nexusclient"
	u "gitedu.hesge.ch/flg_projects/nexus_vdi/nexus/nexush/utils"
)

type AttachSingle struct {
	Name string
}

func (cmd *AttachSingle) GetName() string {
	return cmd.Name
}

func (cmd *AttachSingle) GetDesc() []string {
	return []string{
		"Attaches to a VM in order to use its desktop environment.",
		"If not the VM's owner: requires VM_ATTACH VM access capability or VM_ATTACH_ANY user capability."}
}

func (cmd *AttachSingle) PrintUsage() {
	for _, desc := range cmd.GetDesc() {
		u.PrintlnErr(desc)
	}
	u.PrintlnErr("―――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――")
	u.PrintlnErr("USAGE: ", cmd.GetName(), " ID")
	u.PrintlnErr("―――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――――")
}

func (cmd *AttachSingle) Run(client *nc.NexusClient, args []string) int {
	argc := len(args)
	if argc != 1 {
		cmd.PrintUsage()
		return 1
	}

	vmID := args[0]

	go func() {
		err := client.VMAttachFromID(vmID, false)
		if err != nil {
			u.PrintlnErr("Failed attaching to VM: " + err.Error())
		}
	}()

	return 0
}
