package cmdVM

import (
	nc "gitedu.hesge.ch/flg_projects/nexus_vdi/nexus/libclient/nexusclient"
	u "gitedu.hesge.ch/flg_projects/nexus_vdi/nexus/nexush/utils"
)

type Start struct {
	Name string
}

func (cmd *Start) GetName() string {
	return cmd.Name
}

func (cmd *Start) GetDesc() []string {
	return []string{
		"Starts one or more VMs.",
		"If not the VM's owner: requires VM_START VM access capability or VM_START_ANY user capability."}
}

func (cmd *Start) PrintUsage() {
	printRegexUsage(cmd)
	printRegexUsageDetails()
}

func (cmd *Start) Run(client *nc.NexusClient, args []string) int {
	argc := len(args)
	if argc < 1 {
		cmd.PrintUsage()
		return 1
	}

	vms, err := getFilteredVMs(client, args)
	if err != nil {
		u.PrintlnErr(err)
		return 1
	}
	if len(vms) < 1 {
		u.PrintlnErr("VM(s) not found")
		return 1
	}

	statusCode := 0

	for _, vm := range vms {
		err := client.VMStart(vm.ID.String())
		if err != nil {
			u.PrintlnErr(err)
			statusCode = 1
		} else {
			u.Println("Started VM \"" + vm.Name + "\"")
		}
	}

	// Unused, here to show how we would handle multiple VM start in a single request.
	/*
		vmIDs := make([]string, len(vms))
		for i, vm := range vms {
			vmIDs[i] = vm.ID.String()
		}

		err = client.VMStartMulti(vmIDs)
		if err != nil {
			u.PrintlnErr(err)
			statusCode = 1
		} else {
			u.Println("OK")
		}
	*/

	return statusCode
}
